//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|                                       mod. by lukas1                 
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  1
#property  indicator_level1  0.0
#property  indicator_level2  0.0001
#property  indicator_level3 -0.0001
#property  indicator_level4  0.0002
#property  indicator_level5 -0.0002
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int LevelHigh=15;   //  
extern int LevelLow =-15;  //  
extern int Use_Sound = 1;  // . .  = "0"
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD+Alert("+FastEMA+","+SlowEMA+","+SignalSMA+"),Alert= "+LevelHigh+"/"+LevelLow);
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      {MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
      }
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- signal line counted in the 2-nd buffer
   if(MacdBuffer[1]<LevelHigh*Point && MacdBuffer[0]>=LevelHigh*Point && Use_Sound==1)
     {PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");  }
   if(MacdBuffer[1]>LevelLow*Point  && MacdBuffer[0]<=LevelLow*Point  && Use_Sound==1)
     {PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");  }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+